/*
 * ********************************************************************************************************************
 *
 *                      :*$@@%$*:                         ;:                ;;    ;;
 *                    :@@%!  :!@@%:                       %!             ;%%@@%$ =@@@@@@@%;     @%@@@%%%%@@@@@
 *                   :@%;       :$=                       %%$$$%$$         ;$$  ;$@=   !@$
 *                   =@!                                  %!              @ $=;%   !@@@%:      !$$$$$$$$$$$$$$=
 *                   =@*                                  %!              @ $= % %@=   =%@!      %=
 *              *$%%! @@=        ;=$%%%$*:                %!              @ $= % =%%%%%%@$      *%:         =%
 *            %@@!:    !@@@%=$@@@@%!  :*@@$:              %!              @ $= % $*     ;@      @*          :%*
 *          ;@@!          ;!!!;:         ;@%:      =======@%========*     @ $$ % $%*****$@     :@$=*********=@$
 *          $@*   ;@@@%=!:                *@*
 *          =@$    ;;;!=%@@@@=!           =@!
 *           %@$:      =@%: :*@@@*       %@=                    Copyright (c) 2016-2019.  北京上格云技术有限公司
 *            ;%@@$=$@@%*       *@@@$=%@@%;
 *               ::;::             ::;::                                              All rights reserved.
 *
 * ********************************************************************************************************************
 */

import { FloorScene } from "./FloorScene";
import { MarkerItem } from "./items/MarkItem";
import { SMouseEvent } from "@sybotan-web/graphy/lib";
import { Marker } from "./types/Marker";

/**
 * 位置标签绘制标志
 *
 * @author 郝建龙
 */
export class LocationPointScene extends FloorScene {
    /** 标志list    */
    markerList: Marker[] = [];

    /**
     * 构造函数
     *
     * @param   data
     */
    constructor() {
        super();
    } // Constructor

    /**
     * 添加标志list至scene中
     *
     * @param   marker    标志对象list
     */
    addMarkerList(markerList: Marker[]): void {
        markerList.map(t => {
            this.addMarker(t);
        });
    } // Function addMarkerList()

    /**
     * 添加标志到scene中
     *
     * @param   marker  标志对象
     */
    addMarker(marker: Marker) {
        let flag = new MarkerItem(null, marker);
        flag.moveTo(marker.X, marker.Y);
        flag.zOrder = 9999999;
        this.markerList.push(marker);
        flag.connect("click", this, this.markerClick);
        this.addItem(flag);
    } // Function addMarker()

    /**
     * 标志的点击事件
     *
     * @param   item    点击的旗子item
     * @param   event   点击的事件
     */
    markerClick(item: MarkerItem, event: SMouseEvent) {
        console.log(this.data);
        console.log(arguments);
        alert(1);
    } // Function markerClick()
} // Class LocationPointScene
